import React from 'react';
import { CSSTransition, TransitionGroup } from 'react-transition-group';
import PropagateLoader from 'react-spinners/PropagateLoader';

import CreateCategoryForm from "./CreateCategoryForm";
import ChangeCategory from "./ChangeCategory";
import DeleteCategory from './DeleteCategory';

import store from './../../../state';


class GetCategory extends React.Component {

    state = {
        click: false,
        clicked: false,
        categorys: { // categorIEs
            id: null,
            names: null
        },
        chpic: false,
        massCategory: null,
    }
    componentDidMount() {
        const { category } = this.props;
        this.setState({ massCategory: category.data })
    }

    cclics = () => { //cliCKS
        this.setState((prevState) => ({ click: !prevState.click }));

    }
    deleteClick = () => {
        const { massCategory, categorys: { id } } = this.state;
        for (let key in massCategory) {
            if (massCategory[key]._id == id) {
                delete massCategory[key]
            }
            else {
            }
        }
        this.setState((prevState) => ({ clicked: !prevState.clicked }))
    }

    componentWillReceiveProps(nextProps) {
        const { data, isFlag, actions: { changeCategoryRequest }, changeCategory } = nextProps;
        const { massCategory } = this.state;

        if (data) {
            this.setState(prevState => {
                this.setState({ massCategory: this.state.massCategory.concat(data) });
                store.dispatch({
                    type: 'wtfCreate'
                })
            })
        }
        if (changeCategory.data) {
            for (const key in massCategory) {
                if (massCategory[key]._id === changeCategory.data._id) {
                    this.setState(prevState => {
                        const categoriesArray = prevState.massCategory.slice();
                        categoriesArray.splice(key, 1, changeCategory.data);

                        return {
                            massCategory: categoriesArray
                        }
                    })
                    break;
                }
            }
            store.dispatch({
                type: 'wtfUpdate'
            })
        }

        return true
    }

    onClicked = ({ mass: { _id, name } }) => {
        this.setState({ categorys: { id: _id, name: name } })
        this.setState((prevState) => ({ clicked: !prevState.clicked }))
    }

    render() {
        const { actions: { createCategoryRequest, changeCategoryRequest }, data } = this.props;
        const { category } = this.props;
        const { handelClick, onClicked, deleteClick, changeCategoryClick } = this;
        const { click, categorys, newCategory, massCategory, clicked } = this.state;
        console.log(this.state)

        return (
            <div>
            <div className="overflow-hidden padding profile-page  d-flex flex-row font-ci">
                <div className="slideDown w-100 p-5 bg-gradient border rounded">
                    <div className=" text-center  text-white font-ci font-ci-bold ">
                    {
                        massCategory !== null
                            ?
                            massCategory.map(mass =>
                                <div className="btn " key={mass.id}>
                                    <button class="btn btn-secondary font-ci font-ci-bold text-light bg-mist " onClick={onClicked.bind(null, { mass })} type="button" id={mass.id} key={mass.id} >
                                        {mass.name}
                                    </button>
                                </div>

                            )
                            :
                            null
                    }
                    <div>
                        {
                            click
                                ?
                                <CreateCategoryForm newCategory={newCategory} actions={{ createCategoryRequest }} handlers={{ handelClick }}></CreateCategoryForm>
                                :
                                <button className="btn  btn-outline-light bg-stone m-3" type='button' onClick={this.cclics}>Create Category</button>
                        }
                    </div>

                </div>
                {
                    clicked
                        ?
                        <div>
                            <ChangeCategory actions={{ changeCategoryRequest }} categorys={categorys} handlers={{ changeCategoryClick,deleteClick }}></ChangeCategory>
                            {/* <DeleteCategory categorys={categorys} handlers={{  }} ></DeleteCategory> */}
                        </div>
                        :
                        null
                }
                </div>
                </div>
            </div>
        )
    }

}


export default GetCategory;