import React from 'react';

import formInput from '../../common/formInput';
import { Field, reduxForm } from 'redux-form';
import validate from '../../../configs/validate'


class ChangeUsers extends React.Component {


    submit = ({ name, email, newPassword, confirmPassword }) => {
        const { action: { changeUserRequest }, initialValues: { _id } } = this.props
        changeUserRequest({
            name,
            email,
            newPassword,
            confirmPassword,
            _id
        })
    }

    deleteUser=()=>{
        const {action:{deleteUsersRequest},initialValues: { _id }}=this.props
        deleteUsersRequest({_id})
        
    }



    render() {
        const { initialValues, handleSubmit } = this.props;
        const { submit, deleteUser } = this

        return (
            <div>

                <form onSubmit={handleSubmit(submit)} className="ml-3 mr-3 mt-3">
                    <h5 className="font-ci font-ci-bold text-white mb-3">User Name</h5>
                    <Field name="name" type="name" component={formInput} className="form-control mb-3" />
                    <h5 className="font-ci font-ci-bold text-white mb-3">Email</h5>
                    <Field name="email" type="email" component={formInput} className="form-control mb-3"/>
                    <h5 className="font-ci font-ci-bold text-white mb-3">Password</h5>
                    <Field name="newPassword" type="password" placeholder="Enter login" component={formInput} className="form-control mb-3"/>
                    <h5 className="font-ci font-ci-bold text-white mb-3">Confirm Password</h5>
                    <Field name="confirmPassword" type="password" placeholder="Enter login" component={formInput} className="form-control mb-3"/>
                    <button className= "btn  btn-outline-light bg-stone">Change</button>
                    <button type="button" className= "btn  btn-outline-light bg-stone" onClick ={handleSubmit(deleteUser)} >Delete</button>
                </form >
            </div>

        )
    }

}



export default reduxForm({
    form: "ChangeUserForm",
    enableReinitialize: true,
    validate
})(ChangeUsers)