import React from 'react';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux'
import { getUserRequest } from '../../../actions/admin/user/getUser';
import { changeUserRequest } from '../../../actions/admin/user/changeUser';
import { deleteUsersRequest } from '../../../actions/admin/user/deleteUser'
import ChangeUser from './changeUsers';
import GetUser from './GetUsers';
import PropagateLoader from 'react-spinners/PropagateLoader';




class DeleteUser extends React.Component {
    state = {
        initialValues: null,
        flag: false
    }
    componentDidMount() {
        const { getUserRequest } = this.props;
        getUserRequest()

    }
    handelClick = ({ el }) => {
        this.setState({ initialValues: el });
        this.setState((prevState) => ({ flag: !prevState.flag }))
    }

    render() {
        const { handelClick } = this
        const { users: { user }, changeUserRequest, changeUser: { data, isFetching }, deleteUsers, deleteUsersRequest } = this.props;
        const { initialValues, flag } = this.state;


        return (
            <div className="overflow-hidden profile-page d-flex flex-row font-ci padding ">
                <div className='slideRight w-25 p-3 bg-gradient border rounded'  >
                    <h4 class=" text-center  text-white font-ci font-ci-bold">USERS</h4>
                    <div class="list-group">
                        {
                            user !== null
                                ?
                                <GetUser data={data} deleteUsers={deleteUsers} initialValues={initialValues} user={user} isFetching={isFetching} handlers={{ handelClick }}></GetUser>
                                :
                                <PropagateLoader />
                        }
                    </div>
                </div>
                <div className='w-75 p-3 bg-gradient ml-3 border rounded slideLeft'  >

                    {
                        flag
                            ?
                            <ChangeUser initialValues={initialValues} action={{ changeUserRequest, deleteUsersRequest }} ></ChangeUser>
                            :
                            null
                    }
                </div>
            </div>
        )
    }

}

const
    mapStateToProps = state => ({
        users: state.users,
        changeUser: state.changeUser,
        deleteUsers: state.deleteUsers
    });

const mapDispatchToProps = dispatch => bindActionCreators({ getUserRequest, changeUserRequest, deleteUsersRequest }, dispatch);

export default connect(mapStateToProps, mapDispatchToProps)(DeleteUser);