import React from 'react';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import { getTopicRequest } from '../../../actions/admin/changeTest/getTopic';
import { getQuestionsRequest } from '../../../actions/admin/changeTest/getQuestions';
import { deleteTopicRequest } from '../../../actions/admin/changeTest/deleteTopic';
import { deleteQuestionRequest } from '../../../actions/admin/changeTest/deleteQuestion';
import { getCategoryRequest } from '../../../actions/admin/category/getCategory';
import { getAnswersRequest } from '../../../actions/admin/changeTest/getAnswers';
import { changeTestRequest } from '../../../actions/admin/changeTest/changeTest';
import { deleteAnswerRequest } from '../../../actions/admin/changeTest/deleteAnswer';




import GetTest from './GetTest';
import GetTopic from './GetTopic';
import EditModal from './OpenModal';




class ChangeTest extends React.Component {
    state = {

        categoryId: null,
        name: null,
        topicId: null,
        description: null,
        answers: [],
        answer: null,
        correct: null,
        price: null,
        simple: null,
        openModal: false,
        toggleModal: false,
        click: false

    }

    openEditModal = ({ el: { _id, description, name } }) => {
        const { getQuestionsRequest } = this.props
        getQuestionsRequest({ _id })
        this.setState(({ openModal: true, toggleModal: false, topicId: _id, description: description, name: name }))
    }

    closeModal = () => { this.setState((prevState) => ({ openModal: !prevState.openModal })) }

    getQuestionClick = ({ el: { _id } }) => {
        const { getTopicRequest } = this.props
        getTopicRequest({ _id })
        this.setState({ categoryId: _id })
    }

    handelClick = ({ el: { answer, correct, price, _id } }) => {
        this.setState({ answer: answer, corrent: correct, price: price });
        this.setState((prevState) => ({ click: !prevState.click }))
    }

    componentWillMount = () => {
        const { getCategoryRequest } = this.props
        getCategoryRequest()
    }
    componentWillReceiveProps(nextProps) {
        const { arrayAnswers: { answers } } = nextProps;
        if (answers !== null) {
            this.setState({ answers: answers })
        }
    }


    render() {
        const { getQuestionClick, openEditModal, closeModal, handelClick, state } = this;
        const { openModal, questionId, name, topicId, description, answers, click } = this.state
        const initialValues = {
            ...state
        }
        const { category: { data, isFlag }, deleteTopic, topic, arrayQuestions, getAnswersRequest, deleteTopicRequest, arrayAnswers, changeTestRequest, newTopic, deleteAnswerRequest, deleteQuestionRequest } = this.props

        return (
            <div className=" profile-page  font-ci padding ">

                {
                    !isFlag
                        ?
                        null
                        :
                        <React.Fragment>
                            <GetTest data={data} handlers={{ getQuestionClick }}></GetTest>
                            {
                                topic.isFlag
                                    ?
                                    <React.Fragment>
                                        <GetTopic handlers={{ openEditModal }} topicId={topicId} deleteTopic={deleteTopic} newTopic={newTopic} topic={topic}></GetTopic>
                                        <EditModal className="bg-mist" visible={openModal} handlers={{ handelClick }} click={click} answers={answers} actions={{ getAnswersRequest, deleteTopicRequest, deleteAnswerRequest, deleteQuestionRequest, changeTestRequest }} arrayQuestions={arrayQuestions} initialValues={initialValues}
                                            handleClose={{ closeModal }}></EditModal>
                                    </React.Fragment>
                                    :
                                    null

                            }

                        </React.Fragment>
                }
            </div>
        )
    }

}

const
    mapStateToProps = state => ({
        topic: state.topic,
        arrayQuestions: state.arrayQuestions,
        deleteTopic: state.deleteTopic,
        deleteQuestion: state.deleteQuestion,
        category: state.category,
        arrayAnswers: state.arrayAnswers,
        newTopic: state.newTopic

    });

const mapDispatchToProps = dispatch => bindActionCreators({ getCategoryRequest, deleteAnswerRequest, getTopicRequest, changeTestRequest, getQuestionsRequest, deleteTopicRequest, deleteQuestionRequest, getAnswersRequest }, dispatch);

export default connect(mapStateToProps, mapDispatchToProps)(ChangeTest);