import React from 'react';
import { reduxForm, Field } from 'redux-form';
import validate from './validate';
import formInput from './../../../common/formInput';

class Form extends React.Component {

    submit = ({ email, password }) => {
        const { signIn } = this.props;
        signIn({
            email,
            password
        })
    }

    render() {
        const { handleSubmit, requestError, invalid } = this.props;


        return (
            <div className="container p-5">
                <div className="row">
                    <div className="col-md-8 col-4 col-lg-5 m-auto p-4  border rounded">
                        <h1 className = "position-absolute pl-5 pr-5 sinein bg-white text-stone">SignIn</h1>

                        <form className="text-center" onSubmit={handleSubmit(this.submit)}>
                            {
                                requestError
                                    ?
                                    <p className="text-af text-uppercase">{requestError}</p>
                                    :
                                    null
                            }

                            <div className="form-group">
                                <label className="text-uppercase font-ci">Email address</label>
                                <Field type="email" name='email' className="form-control" placeholder="name@example.com" component={formInput} />
                            </div>

                            <div className="form-group">
                                <label className="text-uppercase font-ci">Password</label>
                                <Field type="password" name='password' className="form-control" component={formInput} />
                            </div>

                            <button type="submit" className="btn btn-primary" disabled={invalid}>Sign In!</button>
                        </form>
                    </div>
                </div>
                
            </div>
        )
    }
}

export default reduxForm({
    form: "SignIn",
    validate
})(Form)
