import React from 'react';
import { Field, reduxForm } from 'redux-form';

import formInput from '../../../common/formInput';

class ChangeLoginForm extends React.Component {

    submit = ({ name}) => {
        const {actions:{changeLoginRequest},data:{_id},token } = this.props

        changeLoginRequest({
            token,
           _id,
            name
        })
        
    }

    render() {
        const { children, handleSubmit, actions:{changeLoginRequest}, handlers: {  handleClick }, data, token } = this.props;
        const { submit}=this

        return (
            <form onSubmit={handleSubmit(submit)} >
                <Field name="name" type="email" placeholder="Enter new login" component={formInput} className="bg-rgba1 border" />
                <button
                    type="button" className="link link--btn right flex-fill bg-shadow btn text-white font-ci font-ci-bold col-3"  onClick={
                        function() {
                        handleClick();
                            handleSubmit(submit)();
                        }    
                    
                    }>
                    Change
                </button>
            </form >
        )
    }
}

export default reduxForm({
    form: "changeLoginForm",
})(ChangeLoginForm);