import React from 'react';
import { Field, reduxForm } from 'redux-form';
import validate from '../../../../configs/validate'

import formInput from '../../../common/formInput';

class ChangePasswordForm extends React.Component {

    submit = ({password, confirmPassword }) => {
        const {actions:{changePasswordRequest},data:{_id},token } = this.props

        changePasswordRequest({
            token,
           _id,
            password,
            confirmPassword
        })
        
    }

    render() {
        const { children, handleSubmit, actions:{ changePasswordRequest }, handlers: {  handleClicked }, data, token } = this.props;
        const { submit}=this
        return (
            <form onSubmit={handleSubmit(submit)} >
                <Field name="password" type="password" placeholder="Password" className ='' component={formInput} className="bg-rgba1 border" />
                <Field name="confirmPassword" type="password" placeholder="new Password" component={formInput} className="bg-rgba1 border"/>

                <button
                    type="button" className="link link--btn flex-fill bg-shadow btn text-white font-ci font-ci-bold col-3 "  onClick={
                        function() {
                        handleClicked();
                            handleSubmit(submit)();
                        }    
                    
                    }>
                    Change
                </button>
            </form >
        )
    }
}

export default reduxForm({
    form: "changePasswordForm",
    validate
})(ChangePasswordForm);