import React, { lazy } from 'react';

import Landing from './../components/public/landing';
import * as routes from './../constants/routes';

const ProfilePage = lazy(() => import('../components/user/ProfilePage'));
const DeleteUser = lazy(()=>import('../components/admin/deleteUser/index'));
const AddDeleteCategory = lazy(()=> import('../components/admin/addDeleteCategory'));
const CreateTest = lazy(()=> import('../components/admin/CreateTest'));
const ChangeTest = lazy(()=>import('../components/admin/getChangeDeleteTest/index'))
const PassingTests =lazy(()=>import('../components/user/Test/index'))
const Category =lazy(()=>import('../components/user/Categoty'))

const SignIn = lazy(() => import('../components/public/signIn/index'));
const SignUp = lazy(() => import('../components/public/signUp/index'));


const CardsCreator = lazy(() => import('./../components/admin/CardsCreator'))

export default [
    {
        path: routes.LANDING,
        access: 'public',
        component: Landing
    },
    {
        path: routes.SIGN_IN,
        access: 'public',
        component: SignIn
    },
    {
        path: routes.SIGN_UP,
        access: 'public',
        component: SignUp
    },
    {
        path: routes.HOME,
        access: 'user-only',
        component: () => <div>home</div>
    },
    {
        path: routes.CATEGORIES,
        access: 'user-only',
        component: Category
    },
    {
        path: routes.PROFILE,
        access: 'user-only',
        component: ProfilePage
    },
    {
        path: routes.TESTS,
        access: 'user-only',
        component: PassingTests
    },
    {
        path: '/admin',
        access: 'admin-only',
        component: () => <div>Some admin-only component</div>
    },
    {
        path: routes.DELETE_USER,
        access: 'admin-only',
        component: DeleteUser
    },
    {
        path: routes.CREATE_CATEGORY,
        access: 'admin-only',
        component: AddDeleteCategory
    },
    {
        path: routes.CREATE_TEST,
        access: 'admin-only',
        component: CreateTest
    },
    {
        path: routes.CREATE_TEST,
        access: 'public',
        component: CardsCreator
    },
    {
        path: routes.CHANGE_TEST,
        access: 'public',
        component: ChangeTest
    },
    {
        access: 'public',
        component: () => <div>404</div>
    },
]