import * as actionTypes from '../../constants/admin';
import initialState from '../initialState';

export default function changeCategory(state = initialState.changeCategory, {payload, type, error}) {

    switch (type) { // payload.type -> type
        case 'wtfUpdate': {
            return initialState.changeCategory
        }
        case actionTypes.CHANGE_CATEGORY_REQUEST: {
            return {
                ...state,
                isFetching: true,
                isFlag:false,
                data:null,
                error: null
            }
        }
        case actionTypes.CHANGE_CATEGORY_REQUEST_SUCCESS: {
            const { data } = payload;

            return {
                ...state,
                isFetching: false,
                isFlag:true,
                data: data,
                error: null,
            }
        }
        case actionTypes.CHANGE_CATEGORY_REQUEST_FAILURE: {

            return {
                ...state,
                isFetching: false,
                data: null,
                error
            }
        }
        default: {
            return state;
        }
    }
}