import * as actionTypes from '../../constants/admin';
import initialState from './../initialState';

export default function getCategory(state = initialState.category, { payload, type, error }) {

    switch (type) { // payload.type -> type
        case actionTypes.GET_CATEGORY_REQUEST: {
            return {
                ...state,
                isFetching: true
            }
        }
        case actionTypes.GET_CATEGORY_REQUEST_SUCCESS: {
            const { data: { category } } = payload;

            return {
                ...state,
                isFetching: false,
                isFlag: true,
                data: category,
            }
        }
        case actionTypes.GET_CATEGORY_REQUEST_FAILURE: {

            return {
                ...state,
                isFetching: false,
                error
            }
        }
        default: {
            return state;
        }
    }
}