import * as actionTypes from '../../constants/admin';
import initialState from './../initialState';

export default function getUsers(state = initialState.users, { payload, type, error }) {

    switch (type) { // payload.type -> type
        case actionTypes.GET_USERS_REQUEST: {
            return {
                ...state,
                isFetching: true
            }
        }
        case actionTypes.GET_USERS_REQUEST_SUCCESS: {
            const {data:{users}}=payload
            return {
                ...state,
                isFetching: false,
                user:users
            }
        }
        case actionTypes.GET_USERS_REQUEST_FAILURE: {

            return {
                ...state,
                isFetching: false,
                error
            }
        }
        default: {
            return state;
        }
    }
}