import * as actionTypes from '../../../constants/admin';
import initialState from '../../initialState';

export default function getAnswers(state = initialState.arrayAnswers, { payload, type, error }) {

    switch (type) {
        case actionTypes.GET_ANSWERS_REQUEST: {
            return {
                ...state,
                isFetching: true,
                isFlag: false,
                payload
            }
        }
        case actionTypes.GET_ANSWERS_REQUEST_SUCCESS: {
            const {data:{answers}}=payload
            return {
                ...state,
                isFetching: false,
                isFlag: true,
                answers:answers
            }
        }
        case actionTypes.GET_ANSWERS_REQUEST_FAILURE: {

            return {
                ...state,
                isFetching: false,
                error
            }
        }
        default: {
            return state;
        }
    }
}