import * as actionTypes from '../../../constants/admin';
import initialState from '../../initialState';

export default function getQuestions(state = initialState.arrayQuestions, { payload, type, error }) {

    switch (type) {
        case actionTypes.GET_QUESTIONS_REQUEST: {
            return {
                ...state,
                isFetching: true,
                isFlag: false,
                payload
            }
        }
        case actionTypes.GET_QUESTIONS_REQUEST_SUCCESS: {
            const { data: { questions } } = payload
            return {
                ...state,
                isFetching: false,
                isFlag: true,
                questions: questions
            }
        }
        case actionTypes.GET_QUESTIONS_REQUEST_FAILURE: {

            return {
                ...state,
                isFetching: false,
                error
            }
        }
        default: {
            return state;
        }
    }
}