import * as actionTypes from '../../constants/user';
import initialState from '../initialState';

export default function startTest(state = initialState.startTest, {  type, payload }) {
    switch (type) {
        case actionTypes.START_TEST_REQUEST: {
            return {
                ...state,
                isFetching: true,
                payload
            }
        }
        case actionTypes.START_TEST_REQUEST_SUCCESS: {
            const {data} =payload
            return {
                ...state,
                isFetching: false,
                data:data
            }
        }
        case actionTypes.NEXT_TEST_REQUEST_SUCCESS: {
            const {data} =payload
            return {
                ...state,
                isFetching: false,
                data:data
            }
        }
        case actionTypes.START_TEST_REQUEST_FAILURE: {
            const { error } = payload;
            return {
                ...state,
                isFetching: false,
                error
            }
        }
        default: {
            return state;
        }
    }
}