import { put, call } from 'redux-saga/effects';
import axios from 'axios';

import { CREATE_CATEGORY } from '../../../constants/admin';
import { changeCategorySuccess, changeCategoryFailure } from '../../../actions/admin/category/changeCategory';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({payload:{id,name}}) {
    try {
        const config = {
            headers: {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${getItem}`
            }
        }

        const category = yield call(() =>
            axios.put(`${CREATE_CATEGORY}${'/'}${id}`,{
                id,
                name}, config)
        )

        yield put(changeCategorySuccess(category));
    }
    catch ({ message }) {
        yield put(changeCategoryFailure(message));
    }
}