import { put, call } from 'redux-saga/effects';
import axios from 'axios';

import { CREATE_CATEGORY } from '../../../constants/admin';
import { createCategorySuccess, createCategoryFailure } from '../../../actions/admin/category/createCategory';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({payload:{name}}) {
    try {
        const config = {
            headers: {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${getItem}`
            }
        }

        const category = yield call(() =>
            axios.post(CREATE_CATEGORY,{
                name}, config)
        )

        yield put(createCategorySuccess(category));
    }
    catch ({ message }) {
        yield put(createCategoryFailure(message));
    }
}