import { put, call } from 'redux-saga/effects';
import axios from 'axios';

import { CREATE_CATEGORY } from '../../../constants/admin';
import { deleteCategorySuccess, deleteCategoryFailure } from '../../../actions/admin/category/deleteCategory';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({payload:{id}}) {
    try {
        const config = {
            headers: {
                "Authorization": `Bearer ${getItem}`
            }
        }

        const category = yield call(() =>
            axios.delete(`${CREATE_CATEGORY}${'/'}${id}`, config)
                
        )

        yield put(deleteCategorySuccess(category));
    }
    catch ({ message }) {
        yield put(deleteCategoryFailure(message));
    }
}