import { put, call } from 'redux-saga/effects';
import axios from 'axios';
import storageKey from './../../../utils/storageKey';
import { CREATE_CATEGORY } from '../../../constants/admin';
import { getCategorySuccess, getCategoryFailure } from '../../../actions/admin/category/getCategory'

const getItem = localStorage.getItem(storageKey);

export default function* () {

    try {
        const config = {
            headers: {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${getItem}`
            }
        }

        const category = yield call(() =>
            axios.get(`${CREATE_CATEGORY}?size=${50}`, config)
        )

        yield put(getCategorySuccess(category));
    }
    catch ({ message }) {
        yield put(getCategoryFailure(message));
    }
}