import { put, call, all } from 'redux-saga/effects';
import axios from 'axios';

import { CREATE_QUESTIONS, CREATE_ANSVERS, CREATE_TOPICS } from '../../../constants/admin';
import { changeTopicSuccess, changeQuestionSuccess, changeAnswersSuccess, createTopicsFailure} from '../../../actions/admin/changeTest/changeTest';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ( {payload:{name,categoryId,description,question,simple,topicId,questionId,answers}}) {
    // console.log(payload)
    try {

        const headers = {
            "Content-Type": "application/json",
            "Authorization": `Bearer ${getItem}`
        }



        const topic = yield call(
            axios, {
                url: `${CREATE_TOPICS}/${topicId}`,
                method: 'PUT',
                headers,
                data: {
                    name: name,
                    categotyId: categoryId,
                    description: description
                }

            }
        )


        // const { data: { question } } = questionses;
        // console.log(typeof( question._id))

        yield put(changeTopicSuccess(topic));
        
        const questionses = yield call(
            axios, {
                url: `${CREATE_QUESTIONS}/${questionId}`,
                method: 'PUT',
                headers,
                data: {
                    question: question,
                    simple: simple,
                    topicId: topicId
                }

            }
        )
        yield put(changeQuestionSuccess(questionses));


        const answer = yield all(answers.map(el => {
            return call(axios, {
                url: `${CREATE_ANSVERS}/${el._id}`,
                method: 'PUT',
                headers,
                data: {
                    answer: el.answer,
                    price: el.price,
                    correct: el.correct,
                     
                }


            })
        }))


        yield put(changeAnswersSuccess(answer));

    }
    catch ({ message }) {
        yield put(createTopicsFailure(message));
    }
}