import { put, call, all } from 'redux-saga/effects';
import axios from 'axios';

import { CREATE_QUESTIONS, CREATE_ANSVERS } from '../../../constants/admin';
import { createQuestionSuccess, createAnswersSuccess, createTestFailure } from '../../../actions/admin/test/createTest';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({ payload: { questions, array, simple, _id } }) {
    try {

        const headers = {
            "Content-Type": "application/json",
            "Authorization": `Bearer ${getItem}`
        }



        const questionses = yield call(
            axios, {
                url: `https://test-app-a-level.herokuapp.com/questions`,
                method: 'POST',
                headers,
                data: {
                    topicId: _id,
                    question: questions,
                    simple: simple
                }

            }
        )


        const { data: { question } } = questionses;

        yield put(createQuestionSuccess(questionses));

        const responses = yield all(array.map(el => {
            return call(axios, {
                url: CREATE_ANSVERS,
                method: 'POST',
                headers,
                data: {
                    answer: el.answer,
                    price: el.price,
                    correct: el.correct,
                    questionId: question._id
                     
                }


            })
        }))


        yield put(createAnswersSuccess(responses));

    }
    catch ({ message }) {
        yield put(createTestFailure(message));
    }
}