import { put, call, all } from 'redux-saga/effects';
import axios from 'axios';

import { CREATE_TOPICS } from '../../../constants/admin';
import { createTopicsSuccess, createTopicsFailure} from '../../../actions/admin/test/createTopics';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({ payload: { name, description, categoryId} }) {
    try {
         
        const   headers = {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${getItem}`
            }
        
        const topic = yield call(
            axios, {
                url:CREATE_TOPICS,
                method:'POST',
                headers,
                data:{
                name:name,
                categoryId:categoryId,
                description:description
                }
                
            }
        )

    yield put(createTopicsSuccess(topic));

}
    catch ({ message }) {
    yield put(createTopicsFailure(message));
}
}