import { put, call } from 'redux-saga/effects';
import axios from 'axios';

import { CREATE_ANSVERS} from '../../../constants/admin';
import { deleteAnswerSuccess, deleteAnswerFailure } from '../../../actions/admin/changeTest/deleteAnswer';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({ payload: { answers_id } }) {
    try {
        const config = {
            headers: {
                "Authorization": `Bearer ${getItem}`
            }
        }

        const answer = yield call(() =>
            axios.delete(`${CREATE_ANSVERS}${'/'}${answers_id}`, config)

        )

        yield put(deleteAnswerSuccess(answer));
    }
    catch ({ message }) {
        yield put(deleteAnswerFailure(message));
    }
}