import { put, call, all } from 'redux-saga/effects';
import axios from 'axios';

import { CREATE_QUESTIONS } from '../../../constants/admin';
import { getQuestionsSuccess, getQuestionsFailure} from '../../../actions/admin/changeTest/getQuestions';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({payload:{_id}}) {
    try {
         
        const config ={
           headers: {
                "Authorization": `Bearer ${getItem}`
            }
        }
        
        const questions = yield call(() =>
            axios.get(`${CREATE_QUESTIONS}?topic=${_id}` ,config)
        )

    yield put(getQuestionsSuccess(questions));

}
    catch ({ message }) {
    yield put(getQuestionsFailure(message));
}
}