import { put, call } from 'redux-saga/effects';
import axios from 'axios';

import { CHANGE_USER } from './../../../constants/admin';
import { changeUserSuccess, changeUserFailure } from './../../../actions/admin/user/changeUser';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({payload:{name, email, newPassword, _id, confirmPassword}}) {
    try {
        const config = {
            headers: {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${getItem}`
            }
        }

        const user = yield call(() =>
            axios.put(`${CHANGE_USER}${_id}` ,{name:name, emeil:email, password:newPassword, confirmPassword:confirmPassword}, config)
        )

        yield put(changeUserSuccess(user));
    }
    catch ({ message }) {
        yield put(changeUserFailure(message));
    }
}