import { put, call } from 'redux-saga/effects';
import axios from 'axios';

import { CHANGE_USER } from './../../../constants/admin';
import { deleteUsersSuccess, deleteUsersFailure } from './../../../actions/admin/user/deleteUser';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({payload:{ _id}}) {
    // console.log(name, newPassword,email, _id)
    try {
        const config = {
            headers: {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${getItem}`
            }
        }

        const user = yield call(() =>
            axios.delete(`${CHANGE_USER}${_id}`, config)
        )

        yield put(deleteUsersSuccess(user));
    }
    catch ({ message }) {
        yield put(deleteUsersFailure(message));
    }
}