import { put, call } from 'redux-saga/effects';
import axios from 'axios';

import { USER_URL } from './../../constants/user';
import { changeLoginSuccess, changeLoginFailure } from './../../actions/user/changelogin';
import storageKey from '../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({payload:{_id,name}}) {
    try {
        const config = {
            headers: {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${getItem}`
            }
        }

        const user = yield call(() =>
            axios.put(`${USER_URL}${_id}`,{name:name}, config)
                .then(({ data }) => data)
        )

        yield put(changeLoginSuccess(user));
    }
    catch ({ message }) {
        yield put(changeLoginFailure(message));
    }
}