import { put, call } from 'redux-saga/effects';
import axios from 'axios';

import { USER_URL } from './../../constants/user';
import { changePasswordSuccess, changePasswordFailure } from './../../actions/user/changePassword';
import storageKey from '../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({payload:{_id, password, confirmPassword}}) {
    try {
        const config = {
            headers: {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${getItem}`
            }
        }

        const user = yield call(() =>
            axios.put(`${USER_URL}${_id}`,{
                password, confirmPassword}, config)
                .then(({ data }) => data)
        )

        yield put(changePasswordSuccess(user));
    }
    catch ({ message }) {
        yield put(changePasswordFailure(message));
    }
}