import { put, call, all } from 'redux-saga/effects';
import axios from 'axios';

import { CHECK_TEST } from '../../../constants/user';
import { checkTestSuccess, checkTestFailure } from '../../../actions/user/test/checkTest';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({ payload: { _id } }) {
    try {


        const headers = {
            "Content-Type": "application/json",
            "Authorization": `Bearer ${getItem}`
        }

        const check = yield call(
            axios, {
                url: CHECK_TEST,
                method: 'POST',
                headers,
                data: {
                    topicId:_id
                }

            }
        )


        yield put(checkTestSuccess(check));

    }
    catch ({ message }) {
        yield put(checkTestFailure(message));
    }
}