import { put, call, all } from 'redux-saga/effects';
import axios from 'axios';

import { NEXT_TEST } from '../../../constants/user';
import { nextTestSuccess, nextTestFailure } from '../../../actions/user/test/nextTest';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ( {payload:{sessionId,_id,answers, question} }) {
    try {


        const headers = {
            "Content-Type": "application/json",
            "Authorization": `Bearer ${getItem}`
        }

        const next = yield call(
            axios, {
                url: NEXT_TEST,
                method: 'POST',
                headers,
                data: {
                    topicId:_id,
                    sessionId:sessionId,
                    prevQuestion:question,
                    answers:answers
                    
                }

            }
        )


        yield put(nextTestSuccess(next));

    }
    catch ({ message }) {
        yield put(nextTestFailure(message));
    }
}