import { put, call, all } from 'redux-saga/effects';
import axios from 'axios';

import { START_TEST } from '../../../constants/user';
import { startTestSuccess, startTestFailure } from '../../../actions/user/test/testStart';
import storageKey from '../../../utils/storageKey';

const getItem = localStorage.getItem(storageKey);

export default function* ({ payload: { _id } }) {
    try {


        const headers = {
            "Content-Type": "application/json",
            "Authorization": `Bearer ${getItem}`
        }

        const start = yield call(
            axios, {
                url: START_TEST,
                method: 'POST',
                headers,
                data: {
                    topicId:_id
                }

            }
        )


        yield put(startTestSuccess(start));

    }
    catch ({ message }) {
        yield put(startTestFailure(message));
    }
}